#ifndef _STACK_H
#define _STACK_H

const unsigned int MAX = 50;

class StackIterator;

// Classe para pilha de numeros.
class Stack {
   // Indica classe "friend" para percorrer (interar) elementos da pilha.
   friend class StackIterator;

 private:
   // Atributo: indice do elemento do topo da pilha.
   int top;
   // Atributo: pilha de numeros e' armazenada como um vetor.
   float *elems;

 public:
   // Construtor com parametro default "size" definido pela constante "MAX".
   // Inicializa "top" com valor nulo, indicando que a pilha esta' vazia.
   // Aloca dinamicamente vetor de numeros com tamanho "size".
   Stack(unsigned int size = MAX) { /*** COMPLETE AQUI: 01 ***/ }

   // Destrutor: elimina vetor de numeros.
   ~Stack()                       { /*** COMPLETE AQUI: 02 ***/ }

   // Metodo para inserir um valor dado no topo da pilha de numeros.
   // Depois de inserir, incrementa o indice "top".
   void push(float val)           { /*** COMPLETE AQUI: 03 ***/ }

   // Metodo para retornar o valor do topo da pilha de numeros.
   // Para ter acesso ao valor do topo, e' necessario decrementar antes o 
   // indice "top".
   float pop()                    { /*** COMPLETE AQUI: 04 ***/ }

   // Metodo para verificar se a pilha esta' vazia.  Retorna "true" se a
   // pilha de numeros estiver vazia; seno retorna "false".
   bool empty()                   { /*** COMPLETE AQUI: 05 ***/ }
};

// Classe "friend" que cria um objeto para percorrer (iterar) os elementos
// de uma pilha da classe "Stack".
class StackIterator {
 private:
   int current;
   Stack *st;
 public:
   StackIterator(Stack *s) { st = s; current = 0;         }
   bool end()              { return st->top == current;   }
   float next()            { return st->elems[current++]; }
};

#endif
